import { find } from "../dom/traverse";
export function createComponentInitializer(selector, action) {
    const alreadyInitialized = new WeakMap();
    return (container) => {
        const mounts = container.matches(selector)
            ? [container]
            : find(selector, container);
        mounts.forEach(mount => {
            if (alreadyInitialized.get(mount)) {
                return;
            }
            alreadyInitialized.set(mount, true);
            action(mount);
        });
    };
}
