export declare type EventIntermediateToken = (any: any) => void;
export declare type DelegatedEventHandler<TEvent extends Event = Event, TElement extends HTMLElement = HTMLElement> = (event: TEvent, element: TElement) => void;
declare type EventHandlerList = {
    [eventType: string]: GenericEventListener<Event>[];
};
declare type GenericEventListener<T extends Event = Event> = {
    (event: T): void;
};
declare type EventHandlerTargets = null | EventTarget | (null | EventTarget)[];
export declare function on<T extends Event = Event>(element: EventHandlerTargets, type: string | string[], handler: GenericEventListener<T>): void;
export declare function off<T extends Event = Event>(element: EventHandlerTargets, type: string | string[], handler: GenericEventListener<T>): void;
export declare function onOff<T extends Event = Event>(element: EventHandlerTargets, type: string | string[], handler: GenericEventListener<T>): () => void;
export declare function once<T extends Event = Event>(element: null | EventTarget, type: string, handler: GenericEventListener<T>): null | EventIntermediateToken;
export declare function delegate<TEvent extends Event = Event, TElement extends HTMLElement = HTMLElement>(element: null | EventTarget, selector: string, type: string, handler: DelegatedEventHandler<TEvent, TElement>): null | EventIntermediateToken;
export declare function trigger(element: null | EventTarget, type: string, data?: any): void;
export declare function getAllListeners(element: EventTarget): EventHandlerList;
export {};
