import { OptionalKeyMap } from "./attr";
import { StylePropertiesMap } from "./css";
export declare type CreateUnstyledElementOptions = OptionalKeyMap & {
    text?: string;
    html?: string;
};
export declare type CreateElementOptions = CreateUnstyledElementOptions & {
    css?: StylePropertiesMap;
};
export declare type InsertableElement = string | Element | Element[];
export declare function createElement<T extends HTMLElement = HTMLElement>(type: string, attributes?: CreateElementOptions): T;
export declare function createUnstyledElement<T extends HTMLElement = HTMLElement>(type: string, attributes?: CreateUnstyledElementOptions): T;
export declare function remove(element: Element | Element[] | null): void;
export declare function empty(element: HTMLElement | HTMLElement[]): void;
export declare function replace(element: Element, replacement: Element): void;
export declare function append(reference: Element, insert: InsertableElement): void;
export declare function prepend(reference: Element, insert: InsertableElement): void;
export declare function before(reference: Element, insert: InsertableElement): void;
export declare function after(reference: Element, insert: InsertableElement): void;
export declare function toggleClass(element: Element, classNames: string | string[], add: boolean): void;
