import fetch from "./fetch";
import { find } from "../dom/traverse";
export default () => {
    if (!/\bTrident\/[567]\b|\bMSIE (?:9|10)\.0\b/.test(navigator.userAgent) &&
        !/\bEdge\/12\.(\d+)\b/.test(navigator.userAgent)) {
        return;
    }
    const useElements = find("svg use");
    const usages = {};
    for (let i = 0; i < useElements.length; i++) {
        const url = (useElements[i].getAttribute("xlink:href") || "").split("#");
        if (2 !== url.length) {
            return;
        }
        if (usages[url[0]] === undefined) {
            usages[url[0]] = [];
        }
        usages[url[0]].push({
            hash: url[1],
            element: useElements[i],
        });
    }
    for (const url in usages) {
        fetch(url)
            .then(response => response.text())
            .then((data) => {
            const svg = (new DOMParser()).parseFromString(data, "image/svg+xml");
            const root = svg.firstElementChild;
            if (null === root) {
                return;
            }
            document.body.appendChild(root);
            for (let i = 0; i < usages[url].length; i++) {
                const el = usages[url][i];
                el.element.setAttribute("xlink:href", `#${el.hash}`);
            }
        });
    }
};
