import { animate } from "./animation";
export function getScrollParent(node) {
    if (!node || !(node instanceof Element)) {
        return null;
    }
    const overflowY = window.getComputedStyle(node).overflowY || "";
    const isScrollable = (overflowY.indexOf('visible') + overflowY.indexOf('hidden')) === -2;
    if (isScrollable && node.scrollHeight >= node.clientHeight) {
        return node;
    }
    return getScrollParent(node.parentNode);
}
export function scrollToElement(element, inContainer) {
    if (element.scrollIntoView) {
        element.scrollIntoView({ behavior: "smooth" });
        return;
    }
    let scrollContainer = inContainer || getScrollParent(element) || document.documentElement;
    animate(scrollContainer, {
        scrollTop: element.offsetTop,
    });
}
