import { h } from "preact";
export function DefaultToast(props) {
    let wrapperClasses = "toast";
    let action = null;
    if (props.impact) {
        wrapperClasses += ` toast-${props.impact}`;
    }
    if (null != props.action) {
        let doAction = props.action.action;
        action = (typeof doAction === "string")
            ? h("a", { href: doAction, class: "toast-action-button" }, props.action.label)
            : h("button", { type: "button", class: "toast-action-button", onClick: doAction }, props.action.label);
    }
    return (h("div", { class: wrapperClasses },
        h("div", { class: "toast-message content" }, props.children),
        null !== action && (h("div", { class: "toast-action" }, action))));
}
