import { useEffect } from "preact/hooks";
import Sortable from "./Sortable";
export function useSortable(ref, sortableOptions, onChange, idFetcher) {
    let fetcher = idFetcher || (element => parseInt(element.dataset.id || "", 10));
    useEffect(() => {
        if (!ref.current || false === sortableOptions.enabled) {
            return;
        }
        let sortable = new Sortable(ref.current, sortableOptions);
        sortable.init();
        sortable.on("changed", (result) => {
            let before = result.result.before;
            onChange(fetcher(result.result.item), before ? fetcher(before) : null);
        });
        return () => sortable.destroy();
    }, [ref.current, JSON.stringify(sortableOptions)]);
}
